<?php

class NetrefConverter extends Converter
{   
    private static $handle = null;
    
    function getInstance()
    {
        if( !self::$handle ) self::$handle = new NetrefConverter;
        return self::$handle;
    }

    function convertSites()
    {        
        $this->setOldDb();                         
        $result = $this->query( 'select * from `NRef_site`;' , $this->dbOld );
        /*nom 	url 	actif 	description 	email 	mot 	cat 	root 	compt_in 	compt_out 	id 	langue 	star 	date_inser 	nb_com 	awards*/
        
        $this->setNewDb();
        
        $this->query( 'delete from `'.$this->dbNewPrefix.'sites`;' , $this->dbNew );

        /* extra things*/
        $this->query( 'delete from `'.$this->dbNewPrefix.'votes`;' , $this->dbNew );
        $this->query( 'delete from `'.$this->dbNewPrefix.'comments`;' , $this->dbNew );
        /*             */
        
        $this->qObiect->tableName = 'sites';
        $this->qObiect->dbPrefix = $this->dbNewPrefix;
        while( $r = mysql_fetch_assoc($result) )
        {
            if( $r['actif'] != 3 )
            {
                $this->qObiect->reset();
            
                $this->qObiect->add('siteId', $r['id']);
                $this->qObiect->add('categoryId', $r['cat']);
                $this->qObiect->add('siteTitle', $r['nom']);
                $this->qObiect->add('description', strip_tags($r['description']));
                $this->qObiect->add('url', $r['url']);
                
                $this->qObiect->add('webmasterEmail', $r['email']);
                
                $r['date_inser'] = str_replace(array('-',':',' '), '', $r['date_inser']);
                $this->qObiect->add('creationDate', $r['date_inser']);
                
                switch( $r['actif'] )
                {
                    case 1:
                        $status = 'validated';
                        break;
                    default:
                        $status = 'waiting';                
                }
                //proposalForKeywords
                $this->qObiect->add('status', $status);
                $this->qObiect->add('visitsCount', $r['compt_out']);
                $this->qObiect->add('rssTitle', '');
                $this->qObiect->add('returnBond', '');
                $this->qObiect->add('rssFeedOfSite', '');

                $sql = $this->qObiect->getSQL();
                $sql = iconv('ISO-8859-1','utf-8//ignore', $sql);
                $sql = str_replace("\xc2\x80", "\xe2\x82\xac", $sql); 
                $this->query($sql , $this->dbNew);   
            }
        }
        
        return true;
    }

    function convertCategories()
    {        
        $this->setOldDb();                     
        $result = $this->query( 'select * from `NRef_cat`;' , $this->dbOld );
        /*nom 	attach 	id 	chemin 	description 	actif 	nb_site 	im 	sous_cat 	aff_parent 	colonne 	nb_cat 	nb_tot 	id_advertise 	back_url_rewriting*/
        
        $this->setNewDb();
        $this->query( 'delete from `'.$this->dbNewPrefix.'categories`;' , $this->dbNew );
        
        $this->qObiect->tableName = 'categories';
        $this->qObiect->dbPrefix = $this->dbNewPrefix;
       
        while( $r = mysql_fetch_assoc($result) )
        {
            $this->qObiect->reset();
            
            $this->qObiect->add('categoryId', $r['id']);
            $this->qObiect->add('parentCategoryId', $r['attach']);
            $this->qObiect->add('name', $r['nom']);
            $this->qObiect->add('description', $r['description']);
            $this->qObiect->add('imageSrc', 'defaultCategoryImage.gif');
            
            switch( $r['actif'] )
            {
                case 1:
                    $tender = 1;
                    break;
                default:
                    $tender = 0;            
            }
            $this->qObiect->add('possibleTender', $tender, true);
            $this->qObiect->add('validatedSitesCount', $r['nb_site']);
            
            $sql = $this->qObiect->getSQL();
            $sql = iconv('ISO-8859-1', 'utf-8//ignore', $sql);
            $sql = str_replace("\xc2\x80", "\xe2\x82\xac", $sql); 
            $this->query($sql , $this->dbNew);
        }
        
        return true;
    }

    function convertAll()
    {     
        $results = array();
                    
        try
        {
            $results['sites'] = array();
            $this->init(); 
            $this->convertSites();
            
            $results['categories'] = array();  
            $this->convertCategories();
            $this->buildCategoryParents();
        }
        catch(Exception $e)
        {
            $lastKey = end(array_keys($results));
            $results[$lastKey]['error'] = $e->getMessage();
        }
        
        return $results;
    }
}
?>